/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-mavros-0.8.6-0precise-20150909-1208/msg/RadioStatus.msg
 *
 */


#ifndef MAVROS_MESSAGE_RADIOSTATUS_H
#define MAVROS_MESSAGE_RADIOSTATUS_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>

namespace mavros
{
template <class ContainerAllocator>
struct RadioStatus_
{
  typedef RadioStatus_<ContainerAllocator> Type;

  RadioStatus_()
    : header()
    , rssi(0)
    , remrssi(0)
    , txbuf(0)
    , noise(0)
    , remnoise(0)
    , rxerrors(0)
    , fixed(0)  {
    }
  RadioStatus_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , rssi(0)
    , remrssi(0)
    , txbuf(0)
    , noise(0)
    , remnoise(0)
    , rxerrors(0)
    , fixed(0)  {
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef uint8_t _rssi_type;
  _rssi_type rssi;

   typedef uint8_t _remrssi_type;
  _remrssi_type remrssi;

   typedef uint8_t _txbuf_type;
  _txbuf_type txbuf;

   typedef uint8_t _noise_type;
  _noise_type noise;

   typedef uint8_t _remnoise_type;
  _remnoise_type remnoise;

   typedef uint16_t _rxerrors_type;
  _rxerrors_type rxerrors;

   typedef uint16_t _fixed_type;
  _fixed_type fixed;




  typedef boost::shared_ptr< ::mavros::RadioStatus_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::mavros::RadioStatus_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct RadioStatus_

typedef ::mavros::RadioStatus_<std::allocator<void> > RadioStatus;

typedef boost::shared_ptr< ::mavros::RadioStatus > RadioStatusPtr;
typedef boost::shared_ptr< ::mavros::RadioStatus const> RadioStatusConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::mavros::RadioStatus_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::mavros::RadioStatus_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace mavros

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'mavros': ['/tmp/buildd/ros-hydro-mavros-0.8.6-0precise-20150909-1208/msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'diagnostic_msgs': ['/opt/ros/hydro/share/diagnostic_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::mavros::RadioStatus_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::mavros::RadioStatus_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mavros::RadioStatus_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mavros::RadioStatus_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mavros::RadioStatus_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mavros::RadioStatus_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::mavros::RadioStatus_<ContainerAllocator> >
{
  static const char* value()
  {
    return "6f756e25cbec426b98a822e4ecb53638";
  }

  static const char* value(const ::mavros::RadioStatus_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x6f756e25cbec426bULL;
  static const uint64_t static_value2 = 0x98a822e4ecb53638ULL;
};

template<class ContainerAllocator>
struct DataType< ::mavros::RadioStatus_<ContainerAllocator> >
{
  static const char* value()
  {
    return "mavros/RadioStatus";
  }

  static const char* value(const ::mavros::RadioStatus_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::mavros::RadioStatus_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# RADIO_STATUS message\n\
\n\
Header header\n\
uint8 rssi\n\
uint8 remrssi\n\
uint8 txbuf\n\
uint8 noise\n\
uint8 remnoise\n\
uint16 rxerrors\n\
uint16 fixed\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
";
  }

  static const char* value(const ::mavros::RadioStatus_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::mavros::RadioStatus_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.rssi);
      stream.next(m.remrssi);
      stream.next(m.txbuf);
      stream.next(m.noise);
      stream.next(m.remnoise);
      stream.next(m.rxerrors);
      stream.next(m.fixed);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct RadioStatus_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::mavros::RadioStatus_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::mavros::RadioStatus_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "rssi: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.rssi);
    s << indent << "remrssi: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.remrssi);
    s << indent << "txbuf: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.txbuf);
    s << indent << "noise: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.noise);
    s << indent << "remnoise: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.remnoise);
    s << indent << "rxerrors: ";
    Printer<uint16_t>::stream(s, indent + "  ", v.rxerrors);
    s << indent << "fixed: ";
    Printer<uint16_t>::stream(s, indent + "  ", v.fixed);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MAVROS_MESSAGE_RADIOSTATUS_H
