/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-mavros-0.8.6-0precise-20150909-1208/srv/SetMode.srv
 *
 */


#ifndef MAVROS_MESSAGE_SETMODEREQUEST_H
#define MAVROS_MESSAGE_SETMODEREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace mavros
{
template <class ContainerAllocator>
struct SetModeRequest_
{
  typedef SetModeRequest_<ContainerAllocator> Type;

  SetModeRequest_()
    : base_mode(0)
    , custom_mode()  {
    }
  SetModeRequest_(const ContainerAllocator& _alloc)
    : base_mode(0)
    , custom_mode(_alloc)  {
    }



   typedef uint8_t _base_mode_type;
  _base_mode_type base_mode;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _custom_mode_type;
  _custom_mode_type custom_mode;


    enum { MAV_MODE_PREFLIGHT = 0 };
     enum { MAV_MODE_STABILIZE_DISARMED = 80 };
     enum { MAV_MODE_STABILIZE_ARMED = 208 };
     enum { MAV_MODE_MANUAL_DISARMED = 64 };
     enum { MAV_MODE_MANUAL_ARMED = 192 };
     enum { MAV_MODE_GUIDED_DISARMED = 88 };
     enum { MAV_MODE_GUIDED_ARMED = 216 };
     enum { MAV_MODE_AUTO_DISARMED = 92 };
     enum { MAV_MODE_AUTO_ARMED = 220 };
     enum { MAV_MODE_TEST_DISARMED = 66 };
     enum { MAV_MODE_TEST_ARMED = 194 };
 

  typedef boost::shared_ptr< ::mavros::SetModeRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::mavros::SetModeRequest_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct SetModeRequest_

typedef ::mavros::SetModeRequest_<std::allocator<void> > SetModeRequest;

typedef boost::shared_ptr< ::mavros::SetModeRequest > SetModeRequestPtr;
typedef boost::shared_ptr< ::mavros::SetModeRequest const> SetModeRequestConstPtr;

// constants requiring out of line definition

   

   

   

   

   

   

   

   

   

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::mavros::SetModeRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::mavros::SetModeRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace mavros

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'mavros': ['/tmp/buildd/ros-hydro-mavros-0.8.6-0precise-20150909-1208/msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'diagnostic_msgs': ['/opt/ros/hydro/share/diagnostic_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::mavros::SetModeRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::mavros::SetModeRequest_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mavros::SetModeRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mavros::SetModeRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mavros::SetModeRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mavros::SetModeRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::mavros::SetModeRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "d770431847cad3a8f50a81ec70ddf0e2";
  }

  static const char* value(const ::mavros::SetModeRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xd770431847cad3a8ULL;
  static const uint64_t static_value2 = 0xf50a81ec70ddf0e2ULL;
};

template<class ContainerAllocator>
struct DataType< ::mavros::SetModeRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "mavros/SetModeRequest";
  }

  static const char* value(const ::mavros::SetModeRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::mavros::SetModeRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
\n\
\n\
uint8 MAV_MODE_PREFLIGHT		= 0\n\
uint8 MAV_MODE_STABILIZE_DISARMED	= 80\n\
uint8 MAV_MODE_STABILIZE_ARMED		= 208\n\
uint8 MAV_MODE_MANUAL_DISARMED		= 64\n\
uint8 MAV_MODE_MANUAL_ARMED		= 192\n\
uint8 MAV_MODE_GUIDED_DISARMED		= 88\n\
uint8 MAV_MODE_GUIDED_ARMED		= 216\n\
uint8 MAV_MODE_AUTO_DISARMED		= 92\n\
uint8 MAV_MODE_AUTO_ARMED		= 220\n\
uint8 MAV_MODE_TEST_DISARMED		= 66\n\
uint8 MAV_MODE_TEST_ARMED		= 194\n\
\n\
uint8 base_mode\n\
string custom_mode\n\
";
  }

  static const char* value(const ::mavros::SetModeRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::mavros::SetModeRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.base_mode);
      stream.next(m.custom_mode);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct SetModeRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::mavros::SetModeRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::mavros::SetModeRequest_<ContainerAllocator>& v)
  {
    s << indent << "base_mode: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.base_mode);
    s << indent << "custom_mode: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.custom_mode);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MAVROS_MESSAGE_SETMODEREQUEST_H
