/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-mavros-0.8.6-0precise-20150909-1208/srv/StreamRate.srv
 *
 */


#ifndef MAVROS_MESSAGE_STREAMRATEREQUEST_H
#define MAVROS_MESSAGE_STREAMRATEREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace mavros
{
template <class ContainerAllocator>
struct StreamRateRequest_
{
  typedef StreamRateRequest_<ContainerAllocator> Type;

  StreamRateRequest_()
    : stream_id(0)
    , message_rate(0)
    , on_off(false)  {
    }
  StreamRateRequest_(const ContainerAllocator& _alloc)
    : stream_id(0)
    , message_rate(0)
    , on_off(false)  {
    }



   typedef uint8_t _stream_id_type;
  _stream_id_type stream_id;

   typedef uint16_t _message_rate_type;
  _message_rate_type message_rate;

   typedef uint8_t _on_off_type;
  _on_off_type on_off;


    enum { STREAM_ALL = 0 };
     enum { STREAM_RAW_SENSORS = 1 };
     enum { STREAM_EXTENDED_STATUS = 2 };
     enum { STREAM_RC_CHANNELS = 3 };
     enum { STREAM_RAW_CONTROLLER = 4 };
     enum { STREAM_POSITION = 6 };
     enum { STREAM_EXTRA1 = 10 };
     enum { STREAM_EXTRA2 = 11 };
     enum { STREAM_EXTRA3 = 12 };
 

  typedef boost::shared_ptr< ::mavros::StreamRateRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::mavros::StreamRateRequest_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct StreamRateRequest_

typedef ::mavros::StreamRateRequest_<std::allocator<void> > StreamRateRequest;

typedef boost::shared_ptr< ::mavros::StreamRateRequest > StreamRateRequestPtr;
typedef boost::shared_ptr< ::mavros::StreamRateRequest const> StreamRateRequestConstPtr;

// constants requiring out of line definition

   

   

   

   

   

   

   

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::mavros::StreamRateRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::mavros::StreamRateRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace mavros

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'mavros': ['/tmp/buildd/ros-hydro-mavros-0.8.6-0precise-20150909-1208/msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'diagnostic_msgs': ['/opt/ros/hydro/share/diagnostic_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::mavros::StreamRateRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::mavros::StreamRateRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mavros::StreamRateRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mavros::StreamRateRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mavros::StreamRateRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mavros::StreamRateRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::mavros::StreamRateRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "d12f7661724c8ba25f67ba597bb7d039";
  }

  static const char* value(const ::mavros::StreamRateRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xd12f7661724c8ba2ULL;
  static const uint64_t static_value2 = 0x5f67ba597bb7d039ULL;
};

template<class ContainerAllocator>
struct DataType< ::mavros::StreamRateRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "mavros/StreamRateRequest";
  }

  static const char* value(const ::mavros::StreamRateRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::mavros::StreamRateRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
\n\
\n\
uint8 STREAM_ALL = 0\n\
uint8 STREAM_RAW_SENSORS = 1\n\
uint8 STREAM_EXTENDED_STATUS = 2\n\
uint8 STREAM_RC_CHANNELS = 3\n\
uint8 STREAM_RAW_CONTROLLER = 4\n\
uint8 STREAM_POSITION = 6\n\
uint8 STREAM_EXTRA1 = 10\n\
uint8 STREAM_EXTRA2 = 11\n\
uint8 STREAM_EXTRA3 = 12\n\
\n\
uint8 stream_id\n\
uint16 message_rate\n\
bool on_off\n\
";
  }

  static const char* value(const ::mavros::StreamRateRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::mavros::StreamRateRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.stream_id);
      stream.next(m.message_rate);
      stream.next(m.on_off);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct StreamRateRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::mavros::StreamRateRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::mavros::StreamRateRequest_<ContainerAllocator>& v)
  {
    s << indent << "stream_id: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.stream_id);
    s << indent << "message_rate: ";
    Printer<uint16_t>::stream(s, indent + "  ", v.message_rate);
    s << indent << "on_off: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.on_off);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MAVROS_MESSAGE_STREAMRATEREQUEST_H
