/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-mavros-0.8.6-0precise-20150909-1208/msg/Waypoint.msg
 *
 */


#ifndef MAVROS_MESSAGE_WAYPOINT_H
#define MAVROS_MESSAGE_WAYPOINT_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace mavros
{
template <class ContainerAllocator>
struct Waypoint_
{
  typedef Waypoint_<ContainerAllocator> Type;

  Waypoint_()
    : frame(0)
    , command(0)
    , is_current(false)
    , autocontinue(false)
    , param1(0.0)
    , param2(0.0)
    , param3(0.0)
    , param4(0.0)
    , x_lat(0.0)
    , y_long(0.0)
    , z_alt(0.0)  {
    }
  Waypoint_(const ContainerAllocator& _alloc)
    : frame(0)
    , command(0)
    , is_current(false)
    , autocontinue(false)
    , param1(0.0)
    , param2(0.0)
    , param3(0.0)
    , param4(0.0)
    , x_lat(0.0)
    , y_long(0.0)
    , z_alt(0.0)  {
    }



   typedef uint8_t _frame_type;
  _frame_type frame;

   typedef uint16_t _command_type;
  _command_type command;

   typedef uint8_t _is_current_type;
  _is_current_type is_current;

   typedef uint8_t _autocontinue_type;
  _autocontinue_type autocontinue;

   typedef float _param1_type;
  _param1_type param1;

   typedef float _param2_type;
  _param2_type param2;

   typedef float _param3_type;
  _param3_type param3;

   typedef float _param4_type;
  _param4_type param4;

   typedef double _x_lat_type;
  _x_lat_type x_lat;

   typedef double _y_long_type;
  _y_long_type y_long;

   typedef double _z_alt_type;
  _z_alt_type z_alt;


    enum { FRAME_GLOBAL = 0 };
     enum { FRAME_LOCAL_NED = 1 };
     enum { FRAME_MISSION = 2 };
     enum { FRAME_GLOBAL_REL_ALT = 3 };
     enum { FRAME_LOCAL_ENU = 4 };
     enum { NAV_WAYPOINT = 16 };
     enum { NAV_LOITER_UNLIM = 17 };
     enum { NAV_LOITER_TURNS = 18 };
     enum { NAV_LOITER_TIME = 19 };
     enum { NAV_RETURN_TO_LAUNCH = 20 };
     enum { NAV_LAND = 21 };
     enum { NAV_TAKEOFF = 22 };
 

  typedef boost::shared_ptr< ::mavros::Waypoint_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::mavros::Waypoint_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct Waypoint_

typedef ::mavros::Waypoint_<std::allocator<void> > Waypoint;

typedef boost::shared_ptr< ::mavros::Waypoint > WaypointPtr;
typedef boost::shared_ptr< ::mavros::Waypoint const> WaypointConstPtr;

// constants requiring out of line definition

   

   

   

   

   

   

   

   

   

   

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::mavros::Waypoint_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::mavros::Waypoint_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace mavros

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'mavros': ['/tmp/buildd/ros-hydro-mavros-0.8.6-0precise-20150909-1208/msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'diagnostic_msgs': ['/opt/ros/hydro/share/diagnostic_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::mavros::Waypoint_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::mavros::Waypoint_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mavros::Waypoint_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mavros::Waypoint_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mavros::Waypoint_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mavros::Waypoint_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::mavros::Waypoint_<ContainerAllocator> >
{
  static const char* value()
  {
    return "2173cf54c2af16a135dca8d104aae309";
  }

  static const char* value(const ::mavros::Waypoint_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x2173cf54c2af16a1ULL;
  static const uint64_t static_value2 = 0x35dca8d104aae309ULL;
};

template<class ContainerAllocator>
struct DataType< ::mavros::Waypoint_<ContainerAllocator> >
{
  static const char* value()
  {
    return "mavros/Waypoint";
  }

  static const char* value(const ::mavros::Waypoint_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::mavros::Waypoint_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# Waypoint.msg\n\
#\n\
# ROS representation of MAVLink MISSION_ITEM\n\
# See mavlink documentation\n\
\n\
\n\
\n\
# see enum MAV_FRAME\n\
uint8 frame\n\
uint8 FRAME_GLOBAL = 0\n\
uint8 FRAME_LOCAL_NED = 1\n\
uint8 FRAME_MISSION = 2\n\
uint8 FRAME_GLOBAL_REL_ALT = 3\n\
uint8 FRAME_LOCAL_ENU = 4\n\
\n\
# see enum MAV_CMD\n\
uint16 command\n\
uint16 NAV_WAYPOINT = 16\n\
uint16 NAV_LOITER_UNLIM = 17\n\
uint16 NAV_LOITER_TURNS = 18\n\
uint16 NAV_LOITER_TIME = 19\n\
uint16 NAV_RETURN_TO_LAUNCH = 20\n\
uint16 NAV_LAND = 21\n\
uint16 NAV_TAKEOFF = 22\n\
# TODO: ROI mode\n\
\n\
bool is_current\n\
bool autocontinue\n\
# meaning of this params described in enum MAV_CMD\n\
float32 param1\n\
float32 param2\n\
float32 param3\n\
float32 param4\n\
float64 x_lat\n\
float64 y_long\n\
float64 z_alt\n\
";
  }

  static const char* value(const ::mavros::Waypoint_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::mavros::Waypoint_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.frame);
      stream.next(m.command);
      stream.next(m.is_current);
      stream.next(m.autocontinue);
      stream.next(m.param1);
      stream.next(m.param2);
      stream.next(m.param3);
      stream.next(m.param4);
      stream.next(m.x_lat);
      stream.next(m.y_long);
      stream.next(m.z_alt);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct Waypoint_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::mavros::Waypoint_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::mavros::Waypoint_<ContainerAllocator>& v)
  {
    s << indent << "frame: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.frame);
    s << indent << "command: ";
    Printer<uint16_t>::stream(s, indent + "  ", v.command);
    s << indent << "is_current: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.is_current);
    s << indent << "autocontinue: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.autocontinue);
    s << indent << "param1: ";
    Printer<float>::stream(s, indent + "  ", v.param1);
    s << indent << "param2: ";
    Printer<float>::stream(s, indent + "  ", v.param2);
    s << indent << "param3: ";
    Printer<float>::stream(s, indent + "  ", v.param3);
    s << indent << "param4: ";
    Printer<float>::stream(s, indent + "  ", v.param4);
    s << indent << "x_lat: ";
    Printer<double>::stream(s, indent + "  ", v.x_lat);
    s << indent << "y_long: ";
    Printer<double>::stream(s, indent + "  ", v.y_long);
    s << indent << "z_alt: ";
    Printer<double>::stream(s, indent + "  ", v.z_alt);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MAVROS_MESSAGE_WAYPOINT_H
